Index: trunk/i18n/en.ts
===================================================================
--- trunk/i18n/en.ts	(revision 53)
+++ trunk/i18n/en.ts	(revision 54)
@@ -36,6 +36,6 @@
         <location filename="../src/tspmodel.cpp" line="201"/>
         <location filename="../src/tspmodel.cpp" line="214"/>
-        <location filename="../src/tspmodel.cpp" line="245"/>
-        <location filename="../src/tspmodel.cpp" line="254"/>
+        <location filename="../src/tspmodel.cpp" line="247"/>
+        <location filename="../src/tspmodel.cpp" line="256"/>
         <source>Task Load</source>
         <translation type="unfinished"></translation>
@@ -46,6 +46,6 @@
         <location filename="../src/tspmodel.cpp" line="201"/>
         <location filename="../src/tspmodel.cpp" line="214"/>
-        <location filename="../src/tspmodel.cpp" line="245"/>
-        <location filename="../src/tspmodel.cpp" line="254"/>
+        <location filename="../src/tspmodel.cpp" line="247"/>
+        <location filename="../src/tspmodel.cpp" line="256"/>
         <source>Unable to load task:</source>
         <translation type="unfinished"></translation>
@@ -64,5 +64,5 @@
     <message>
         <location filename="../src/tspmodel.cpp" line="201"/>
-        <location filename="../src/tspmodel.cpp" line="245"/>
+        <location filename="../src/tspmodel.cpp" line="247"/>
         <source>File version is newer than application supports.
 Please, try to update application.</source>
@@ -71,5 +71,5 @@
     <message>
         <location filename="../src/tspmodel.cpp" line="214"/>
-        <location filename="../src/tspmodel.cpp" line="254"/>
+        <location filename="../src/tspmodel.cpp" line="256"/>
         <source>Unexpected data read.
 File is possibly corrupted.</source>
@@ -77,17 +77,17 @@
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="285"/>
-        <location filename="../src/tspmodel.cpp" line="291"/>
-        <location filename="../src/tspmodel.cpp" line="298"/>
-        <location filename="../src/tspmodel.cpp" line="305"/>
-        <location filename="../src/tspmodel.cpp" line="312"/>
-        <location filename="../src/tspmodel.cpp" line="319"/>
-        <location filename="../src/tspmodel.cpp" line="326"/>
-        <location filename="../src/tspmodel.cpp" line="336"/>
+        <location filename="../src/tspmodel.cpp" line="289"/>
+        <location filename="../src/tspmodel.cpp" line="295"/>
+        <location filename="../src/tspmodel.cpp" line="302"/>
+        <location filename="../src/tspmodel.cpp" line="309"/>
+        <location filename="../src/tspmodel.cpp" line="316"/>
+        <location filename="../src/tspmodel.cpp" line="323"/>
+        <location filename="../src/tspmodel.cpp" line="330"/>
+        <location filename="../src/tspmodel.cpp" line="340"/>
         <source>Task Save</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="285"/>
+        <location filename="../src/tspmodel.cpp" line="289"/>
         <source>Unable to create task file.
 Error: %1
@@ -96,11 +96,11 @@
     </message>
     <message>
-        <location filename="../src/tspmodel.cpp" line="291"/>
-        <location filename="../src/tspmodel.cpp" line="298"/>
-        <location filename="../src/tspmodel.cpp" line="305"/>
-        <location filename="../src/tspmodel.cpp" line="312"/>
-        <location filename="../src/tspmodel.cpp" line="319"/>
-        <location filename="../src/tspmodel.cpp" line="326"/>
-        <location filename="../src/tspmodel.cpp" line="336"/>
+        <location filename="../src/tspmodel.cpp" line="295"/>
+        <location filename="../src/tspmodel.cpp" line="302"/>
+        <location filename="../src/tspmodel.cpp" line="309"/>
+        <location filename="../src/tspmodel.cpp" line="316"/>
+        <location filename="../src/tspmodel.cpp" line="323"/>
+        <location filename="../src/tspmodel.cpp" line="330"/>
+        <location filename="../src/tspmodel.cpp" line="340"/>
         <source>Unable to save task.
 Error: %1</source>
@@ -111,26 +111,27 @@
     <name>CTSPSolver</name>
     <message>
-        <location filename="../src/tspsolver.cpp" line="137"/>
+        <location filename="../src/tspsolver.cpp" line="138"/>
         <source>%v of %m parts found</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/tspsolver.cpp" line="141"/>
+        <location filename="../src/tspsolver.cpp" line="142"/>
         <source>Calculating optimal route...</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/tspsolver.cpp" line="142"/>
+        <location filename="../src/tspsolver.cpp" line="143"/>
         <source>Solution Progress</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/tspsolver.cpp" line="210"/>
+        <location filename="../src/tspsolver.cpp" line="209"/>
         <source>Solution Result</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/tspsolver.cpp" line="210"/>
-        <source>This task has no solution.</source>
+        <location filename="../src/tspsolver.cpp" line="209"/>
+        <source>Unable to find solution.
+Maybe, this task has no solutions.</source>
         <translation type="unfinished"></translation>
     </message>
@@ -139,70 +140,75 @@
     <name>MainWindow</name>
     <message>
-        <location filename="../src/mainwindow.cpp" line="146"/>
-        <location filename="../src/mainwindow.cpp" line="492"/>
-        <location filename="../src/mainwindow.cpp" line="501"/>
+        <location filename="../src/mainwindow.cpp" line="543"/>
+        <location filename="../src/mainwindow.cpp" line="552"/>
         <source>Language change</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="146"/>
+        <location filename="../src/mainwindow.cpp" line="162"/>
         <source>Unable to load translation language.</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="192"/>
+        <location filename="../src/mainwindow.cpp" line="204"/>
         <source>Would you like to save changes in current task?</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="170"/>
+        <location filename="../src/mainwindow.cpp" line="186"/>
+        <location filename="../ui/mainwindow.ui" line="14"/>
         <source>Travelling Salesman Problem</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="192"/>
+        <location filename="../src/mainwindow.cpp" line="162"/>
+        <source>Language Change</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../src/mainwindow.cpp" line="204"/>
         <source>Unsaved Changes</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="224"/>
+        <location filename="../src/mainwindow.cpp" line="236"/>
         <source>All Supported Formats</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="225"/>
-        <location filename="../src/mainwindow.cpp" line="226"/>
+        <location filename="../src/mainwindow.cpp" line="237"/>
+        <location filename="../src/mainwindow.cpp" line="238"/>
         <source>%1 Task Files</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="227"/>
-        <location filename="../src/mainwindow.cpp" line="267"/>
-        <location filename="../src/mainwindow.cpp" line="296"/>
+        <location filename="../src/mainwindow.cpp" line="239"/>
+        <location filename="../src/mainwindow.cpp" line="289"/>
+        <location filename="../src/mainwindow.cpp" line="323"/>
         <source>All Files</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="263"/>
+        <location filename="../src/mainwindow.cpp" line="285"/>
         <source>HTML Files</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="265"/>
+        <location filename="../src/mainwindow.cpp" line="287"/>
         <source>OpenDocument Files</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="295"/>
+        <location filename="../src/mainwindow.cpp" line="322"/>
         <source>%1 Task File</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="326"/>
+        <location filename="../src/mainwindow.cpp" line="353"/>
         <source>Settings Changed</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="326"/>
+        <location filename="../src/mainwindow.cpp" line="353"/>
         <source>You have changed color settings.
 Do you wish to apply them to current solution text?</source>
@@ -210,56 +216,56 @@
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="390"/>
+        <location filename="../src/mainwindow.cpp" line="438"/>
         <source>Data error</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="390"/>
+        <location filename="../src/mainwindow.cpp" line="438"/>
         <source>Error in cell [Row %1; Column %2]: Invalid data format.</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="403"/>
+        <location filename="../src/mainwindow.cpp" line="454"/>
         <source>Variant #%1</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="404"/>
+        <location filename="../src/mainwindow.cpp" line="455"/>
         <source>Task:</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="407"/>
-        <location filename="../src/mainwindow.cpp" line="433"/>
+        <location filename="../src/mainwindow.cpp" line="458"/>
+        <location filename="../src/mainwindow.cpp" line="484"/>
         <source>Solution of Variant #%1 task</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="414"/>
+        <location filename="../src/mainwindow.cpp" line="465"/>
         <source>Step #%1</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="417"/>
+        <location filename="../src/mainwindow.cpp" line="468"/>
         <source>This step has alternate candidates for branching.</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="429"/>
+        <location filename="../src/mainwindow.cpp" line="480"/>
         <source>Optimal path:</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="431"/>
+        <location filename="../src/mainwindow.cpp" line="482"/>
         <source>The price is &lt;b&gt;%1&lt;/b&gt; units.</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="492"/>
+        <location filename="../src/mainwindow.cpp" line="543"/>
         <source>Language will be autodetected on next application start.</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="501"/>
+        <location filename="../src/mainwindow.cpp" line="552"/>
         <source>You have language autodetection turned on.
 It needs to be off.
@@ -268,41 +274,36 @@
     </message>
     <message>
-        <location filename="../src/mainwindow.cpp" line="506"/>
-        <location filename="../src/mainwindow.h" line="76"/>
+        <location filename="../src/mainwindow.cpp" line="263"/>
+        <location filename="../src/mainwindow.cpp" line="557"/>
+        <location filename="../src/mainwindow.h" line="78"/>
         <source>Untitled</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="53"/>
-        <location filename="../ui/mainwindow.ui" line="41"/>
+        <location filename="../ui/mainwindow.ui" line="44"/>
         <source>Task</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="74"/>
-        <location filename="../ui/mainwindow.ui" line="62"/>
+        <location filename="../ui/mainwindow.ui" line="65"/>
         <source>&amp;Variant:</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="87"/>
-        <location filename="../ui/mainwindow.ui" line="75"/>
+        <location filename="../ui/mainwindow.ui" line="78"/>
         <source>Number of variant</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="97"/>
-        <location filename="../ui/mainwindow.ui" line="85"/>
+        <location filename="../ui/mainwindow.ui" line="88"/>
         <source>&amp;Cities:</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="110"/>
-        <location filename="../ui/mainwindow.ui" line="98"/>
+        <location filename="../ui/mainwindow.ui" line="101"/>
         <source>Number of cities</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="141"/>
         <location filename="../ui/mainwindow.ui" line="129"/>
         <source>Cost of travel from city to city</source>
@@ -310,5 +311,4 @@
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="169"/>
         <location filename="../ui/mainwindow.ui" line="157"/>
         <source>Fill table with random numbers</source>
@@ -316,5 +316,4 @@
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="172"/>
         <location filename="../ui/mainwindow.ui" line="160"/>
         <source>Random</source>
@@ -322,5 +321,4 @@
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="186"/>
         <location filename="../ui/mainwindow.ui" line="174"/>
         <source>Solve current task</source>
@@ -328,5 +326,4 @@
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="189"/>
         <location filename="../ui/mainwindow.ui" line="177"/>
         <source>Solve</source>
@@ -334,5 +331,4 @@
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="203"/>
         <location filename="../ui/mainwindow.ui" line="191"/>
         <source>Solution</source>
@@ -340,5 +336,4 @@
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="212"/>
         <location filename="../ui/mainwindow.ui" line="200"/>
         <source>Solution steps</source>
@@ -346,18 +341,31 @@
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="242"/>
-        <location filename="../ui/mainwindow.ui" line="230"/>
+        <location filename="../ui/mainwindow.ui" line="221"/>
+        <location filename="../ui/mainwindow.ui" line="424"/>
+        <source>Save solution to a file</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ui" line="224"/>
+        <source>Save Solution</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ui" line="251"/>
+        <source>Go back to Task tab</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ui" line="254"/>
+        <source>Back to Task</source>
+        <translation type="unfinished"></translation>
+    </message>
+    <message>
+        <location filename="../ui/mainwindow.ui" line="284"/>
         <source>&amp;File</source>
         <translation type="unfinished"></translation>
     </message>
     <message>
-        <location filename="../ui/mainwindow.ce.ui" line="249"/>
-        <location filename="../ui/mainwindow.ui" line="234"/>
-        <source>Save &amp;As...</source>
-        <translation type="unfinished"></translation>
-    </message>
-    <message>
-        <location filename="../ui/mainwindow.ce.ui" line="277"/>
-        <location filename="../ui/mainwindow.ui" line="265"/>
+        <location filename="../ui/mainwindow.ui" line="316"/>
         <source>&amp;Language</source>
         <comment>Please, append &quot; / Language&quot; when translating this string.</comment>
